#include "Peak2.h"

STRINGTYPE      =12
HIDDENTYPE      =20

MAXPROGS        =9
NUMPROGS        =TEXT_MEM2
PROGPOINT       =TEXT_MEM2+1
NEXTPAGE        =TEXT_MEM2+3
PROGNAMES       =TEXT_MEM2+5

.org ORIGIN

MenuTitle:
.db     "     Peak BETA 2",0

Start:
        call CLEARLCD

        ld HL,0
        ld (CURSOR_ROW),HL

        ld HL,MenuTitle
        call D_ZT_STR           ;title

        ld HL,PROGNAMES
        ld (PROGPOINT),HL
        xor A
        ld (NUMPROGS),A         ;init

        ld HL,VAT_START

CheckerLoop:
        ld A,STRINGTYPE         ;VAT Checking init
        call CHECK_VAT
        jr C,Done

        push HL

        ex DE,HL
        inc HL
        inc HL

        call LD_HL_MHL

        ld DE,$FD00
        call CP_HL_DE           ;ZShell?
        jr Z,Yes

        ld DE,$5000
        call CP_HL_DE           ;PhatOS?
        jr Z,Yes

        ld DE,$5002
        call CP_HL_DE           ;Peak Relocation?
        jr Z,Yes

        ld DE,$7002
        call CP_HL_DE           ;Peak Non-Relocation?
        jr Z,Yes

        pop HL
        jr CheckerLoop

Yes:
        ld HL,VC_NAME
        ld DE,(PROGPOINT)
        ld BC,9
        ldir
        ld (PROGPOINT),DE

        ld A,(NUMPROGS)
        inc A
        cp MAXPROGS
        ld (NUMPROGS),A
        pop HL

        ld (NEXTPAGE),HL
        jr Z,GotMax

        jr CheckerLoop

Done:
        ld HL,VAT_START
        ld (NEXTPAGE),HL

        ld A,(NUMPROGS)
        or A
        jr Z,CheckerLoop

GotMax:
        ld DE,$0805
        ld A,(NUMPROGS)
        ld B,A
        ld HL,PROGNAMES

DisplayNames:
        push BC
        push DE
        ld (CURSOR_X),DE

        push HL
        ld B,(HL)
        inc HL
        call D_LM_STR
        pop HL

        pop DE
        push DE

        ld E,45
        ld (CURSOR_X),DE

        push HL
        dec HL
        GET_VAR

        ex DE,HL
        inc HL
        inc HL

        inc HL
        inc HL
        inc HL

        call D_ZM_STR

        pop HL
        pop DE

        ld BC,9
        add HL,BC

        pop BC
        
        ld A,6
        add A,D
        ld D,A
        djnz DisplayNames

        ld B,1
        call InvertSelection

KeyLoop:
        call GET_KEY

        cp K_EXIT
        ret Z

        cp K_MORE
        jr Z,More

        cp K_UP
        jr Z,Up

        cp K_DOWN
        jr Z,Down

        cp K_ENTER
        jr Z,Enter

        jr KeyLoop

Enter:
        ld HL,PROGNAMES-10
        ld DE,9

AddToNameLoop:
        add HL,DE
        djnz AddToNameLoop

        LD_OP1_HL
        call EXE
        jp Start

Up:
        call InvertSelection
        dec B
        xor A
        cp B
        jr NZ,SkipLoadBottem

        ld A,(NUMPROGS)
        ld B,A

SkipLoadBottem:
        call InvertSelection
        jr KeyLoop
        
Down:
        call InvertSelection
        inc B
        ld A,(NUMPROGS)
        inc A
        cp B
        jr NZ,SkipLoadTop

        ld B,1

SkipLoadTop:
        call InvertSelection
        jr KeyLoop

More:
        ld HL,VIDEO_MEM+128
        ld D,H
        ld E,L
        inc DE
        ld (HL),0
        ld BC,1024-128
        ldir

        xor A
        ld (NUMPROGS),A

        ld HL,PROGNAMES
        ld (PROGPOINT),HL

        ld HL,(NEXTPAGE)
        jp CheckerLoop

InvertSelection:
        push BC
        push DE
        ld HL,VIDEO_MEM+32

AddLoop:
        ld DE,96
        add HL,DE
        djnz AddLoop

        ld B,112

FillLoop:
        ld A,(HL)
        cpl
        ld (HL),A
        inc HL
        djnz FillLoop

        pop DE
        pop BC
        ret

.end




